#include <stdio.h>
#include <string.h>

FILE *fp;

struct rendszam{            // Ideiglenesen trolt rendszmhoz
    int azonosito;
    char nev[100];
    char rend1[4];
    char rend2[4];
} rendsz_beolv;


struct rendszam_l{          // Listaelem
    int azonosito;
    char nev[100];
    char rend1[4];
    char rend2[4];
    struct rendszam_l *kov; // Kvetkez elem mutatja
} *elso=NULL, *aktualis, *uj, *talalt;

int utolso_azonosito=0;

void ujbevitel(){
    // j rendszm bevitele a listba
    
    printf("Nev: "); fflush(stdin); gets(rendsz_beolv.nev);
    printf("Rendszam (betu resz): "); fflush(stdin); gets(rendsz_beolv.rend1);
    printf("Rendszam (szam resz): "); fflush(stdin); gets(rendsz_beolv.rend2);
    rendsz_beolv.azonosito = ++utolso_azonosito;
    
    aktualis=elso;
    if (aktualis!=NULL)
        while(aktualis->kov!=NULL) aktualis=aktualis->kov;
    
    uj=(struct rendszam_l *)malloc(sizeof(struct rendszam_l));
    strcpy(uj->nev, rendsz_beolv.nev);
    strcpy(uj->rend1, rendsz_beolv.rend1);
    strcpy(uj->rend2, rendsz_beolv.rend2);
    uj->azonosito = rendsz_beolv.azonosito;
    
    uj->kov=NULL;
        if(elso==NULL) elso=uj;
    else aktualis->kov=uj;
}

void keres_nev(){
    // Nv keresse rendszm alapjn
    
    int utasitas;
    printf("Irja be a rendszamot (betu resz): "); fflush(stdin); gets(rendsz_beolv.rend1);
    printf("Irja be a rendszamot (szam resz): "); fflush(stdin); gets(rendsz_beolv.rend2);
    
    talalt=NULL;            // NULL marad ha vgig nem tall elemet, gy jelezzk az esetleges sikertelen keresst
    aktualis=elso;
    while(aktualis!=NULL){
        if( !strcmp(aktualis->rend1, rendsz_beolv.rend1) && !strcmp(aktualis->rend2, rendsz_beolv.rend2) ) {
            talalt=aktualis; break;         // teht ha a rendszm kt fele megegyezett, akkor megvan a keresett nv
        }
        aktualis=aktualis->kov;
    }
    
    if(talalt==NULL) printf("Nincs talalat!\n");
        else {
            printf("A %s-%s rendszam alapjan megtalalt nev: %s, azonositoja %d.\n\n", talalt->rend1, talalt->rend2, talalt->nev, talalt->azonosito);
            printf("Toroljem/modositsam esetleg? 1=torold 2=modositsd 3=egyik sem >");
            scanf("%d", &utasitas);
            if(utasitas==1){
                // a kvetkez elem adatait rja bele, s gyakorlatilag a kvetkezt trli gy, hogy a mutatt eggyel tovbbirnytja
                if(talalt->kov!=NULL){  // de csak ha van kvetkez
                    strcpy(talalt->nev, talalt->kov->nev);
                    strcpy(talalt->rend1, talalt->kov->rend1);
                    strcpy(talalt->rend2, talalt->kov->rend2);
                    talalt->kov = talalt->kov->kov;
                } else if (talalt!=elso){     // ha nincs, akkor megkeresi jra az ELTTE lev elemet, s annak trli a kvetkezre mutatjt - ha van eltte elem
                    aktualis=elso;
                    while(aktualis!=NULL){
                        if( aktualis->kov==talalt ) {
                            aktualis->kov=NULL; break;
                        }
                        aktualis=aktualis->kov;
                    }
                } else elso=NULL;           // ha egyedli elem volt ez a listban, akkor gy trli    
            }else if(utasitas==2){
                printf("Uj nev: "); fflush(stdin); gets(rendsz_beolv.nev);
                printf("Uj rendszam (betu resz): "); fflush(stdin); gets(rendsz_beolv.rend1);
                printf("Uj rendszam (szam resz): "); fflush(stdin); gets(rendsz_beolv.rend2);
                
                strcpy(talalt->nev, rendsz_beolv.nev);
                strcpy(talalt->rend1, rendsz_beolv.rend1);
                strcpy(talalt->rend2, rendsz_beolv.rend2);
            }else ;
        }
}

void keres_rendsz(){
    // Rendszm keresse nv alapjn
    
    int utasitas;
    printf("Irja be a nevet: "); fflush(stdin); gets(rendsz_beolv.nev);
    
    talalt=NULL;            // NULL marad ha vgig nem tall elemet, gy jelezzk az esetleges sikertelen keresst
    aktualis=elso;
    while(aktualis!=NULL){
        if( strcmp(aktualis->nev, rendsz_beolv.nev)==0 ) {
            talalt=aktualis; break;         // teht ha a nv megegyezik, megvan a keresett rendszm
        }
        aktualis=aktualis->kov;
    }
    
    if(talalt==NULL) printf("Nincs talalat!\n");
        else {
            printf("A %s nev alapjan megtalalt rendszam: %s-%s, azonositoja %d.\n\n", talalt->nev, talalt->rend1, talalt->rend2, talalt->azonosito);
            printf("Toroljem/modositsam esetleg? 1=torold 2=modositsd 3=egyik sem >");
                scanf("%d", &utasitas);
                if(utasitas==1){
                    // a kvetkez elem adatait rja bele, s gyakorlatilag a kvetkezt trli gy, hogy a mutatt eggyel tovbbirnytja
                    if(talalt->kov!=NULL){  // de csak ha van kvetkez
                        strcpy(talalt->nev, talalt->kov->nev);
                        strcpy(talalt->rend1, talalt->kov->rend1);
                        strcpy(talalt->rend2, talalt->kov->rend2);
                        talalt->kov = talalt->kov->kov;
                    } else if (talalt!=elso){     // ha nincs, akkor megkeresi jra az ELTTE lev elemet, s annak trli a kvetkezre mutatjt - ha van eltte elem
                        aktualis=elso;
                        while(aktualis!=NULL){
                            if( aktualis->kov==talalt ) {
                                aktualis->kov=NULL; break;
                            }
                            aktualis=aktualis->kov;
                        }
                    } else elso=NULL;           // ha egyedli elem volt ez a listban, akkor gy trli
                }else if(utasitas==2){
                    printf("Uj nev: "); fflush(stdin); gets(rendsz_beolv.nev);
                    printf("Uj rendszam (betu resz): "); fflush(stdin); gets(rendsz_beolv.rend1);
                    printf("Uj rendszam (szam resz): "); fflush(stdin); gets(rendsz_beolv.rend2);
                    
                    strcpy(talalt->nev, rendsz_beolv.nev);
                    strcpy(talalt->rend1, rendsz_beolv.rend1);
                    strcpy(talalt->rend2, rendsz_beolv.rend2);
                }else ;
        }
}

void fajl_ir(){
    // Fjl rsa
    fp=fopen("rendsz.dat","w+");
    aktualis=elso;
    while(aktualis!=NULL){
        strcpy(rendsz_beolv.nev, aktualis->nev);
        strcpy(rendsz_beolv.rend1, aktualis->rend1);
        strcpy(rendsz_beolv.rend2, aktualis->rend2);
        rendsz_beolv.azonosito = aktualis->azonosito;
        fwrite(&rendsz_beolv, sizeof(rendsz_beolv), 1, fp);
        aktualis=aktualis->kov;
    }
    //printf("A fajl frissitve!\n");
    fclose(fp);
}

void listaz(){
    // Adatok listzsa (lista s nem a fjlt alapjn!)
    if(elso==NULL) printf("A lista ures.\n");
        else {
            printf("\n\n");
            aktualis=elso;
            while(aktualis!=NULL){
                strcpy(rendsz_beolv.nev, aktualis->nev);
                strcpy(rendsz_beolv.rend1, aktualis->rend1);
                strcpy(rendsz_beolv.rend2, aktualis->rend2);
                rendsz_beolv.azonosito = aktualis->azonosito;
                
                printf("Nev: %s, rendszam: %s-%s   (azonosito: %d)\n", rendsz_beolv.nev, rendsz_beolv.rend1, rendsz_beolv.rend2, rendsz_beolv.azonosito);
                
                if(aktualis!=NULL) aktualis=aktualis->kov;
            }
    }
}


int main() {
    int parancs;
    int i;
    
    // Megnyitja a fjlt olvassra:
    fp=fopen("rendsz.dat","r+b");
    if(fp==NULL) {          // ha nincs ilyen fjl, ltrehoz egy jat
        fclose(fp);
        fp=fopen("rendsz.dat","w");
        fclose(fp);
        fp=fopen("rendsz.dat","r+b");
    }
    
    // Lncolt listt pt fel a fjl alapjn, ksbb ezzel dolgozik:
    while(!feof(fp)){
        fread(&rendsz_beolv, sizeof(rendsz_beolv),1,fp);
        if(!feof(fp)) {
            uj=(struct rendszam_l *)malloc(sizeof(struct rendszam_l));
            strcpy(uj->nev, rendsz_beolv.nev);
            strcpy(uj->rend1, rendsz_beolv.rend1);
            strcpy(uj->rend2, rendsz_beolv.rend2);
            uj->azonosito = rendsz_beolv.azonosito;
            ++utolso_azonosito;
            
            uj->kov=NULL;
            if(elso==NULL) elso=uj;
                else aktualis->kov=uj;
            aktualis=uj;
        }
    }
    fclose(fp);
    
    
    while(1){
        printf("\n1: Uj rendszam\n2: Nev keresese rendszam alapjan\n3: Rendszam keresese nev alapjan\n4: Jelenlegi adatok listazasa\n5: Kilepes\n\n");
        scanf("%d", &parancs);
        switch(parancs){
              case 1:
                    ujbevitel();
                    break;
              case 2:
                    keres_nev();
                    break;
              case 3:
                    keres_rendsz();
                    break;
              case 4:
                    listaz();
                    break;
              case 5:
                    // Kilps
                    exit(0);
              default:
                    printf("Hibas parancs!\n");
                    break;
        }
        fajl_ir();      // minden mvelet utn frissti a fjlt
    }
    
    getchar();
    return 0;
}
